using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace SparseArray
{
  class Program
  {
    static void Main(string[] args)
    {
      SparseArray<double> arrDouble = new SparseArray<double>();

      arrDouble[0, 0] = 15.0;
      arrDouble[3, 3] = 5.5;
      arrDouble[9, 9] = 7.5;

      Console.WriteLine(arrDouble[0, 0]);
      Console.WriteLine(arrDouble[3, 3]);
      Console.WriteLine(arrDouble[9, 9]);
      Console.WriteLine(arrDouble[100, 100]);
    }
  }

  public class Test
  {
    public int a;
    public double b;

    public Test()
    {
      a = 0;
      b = 0.0;
    }

    public Test(int i, double d)
    {
      a = i;
      b = d;
    }

    public override string ToString()
    {
      return "[" + a.ToString() + "; " + b.ToString() + "]";
    }
  }

  public class SparseArray<T> where T:new()
  {
    Dictionary<long, T> arrData;

    public SparseArray()
    {
      arrData = new Dictionary<long, T>();
    }

    public T this[int i1, int i2]
    {
      get
      {
        T data;

        long ind = ((long)i1 << 32) + i2;

        if (arrData.TryGetValue(ind, out data))
        {
          return data;
        }

        return new T();
      }
      set
      {
        long ind = ((long)i1 << 32) + i2;
        arrData[ind] = value;
      }
    }

    public int Count
    {
      get
      {
        return arrData.Count;
      }
    }
  }
}
